Unit aer3e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure aer3e(NM :Integer; N :Integer; MBW :Integer;
                var A :Array of Extended; E21 :Extended; M :Integer;
                var W :Array of Extended; var Z :Array of Extended;
                var IERR :Integer; NV :Integer;
                var RV :Array of Extended; var RV6 :Array of Extended);

implementation

procedure aer3e(NM :Integer; N :Integer; MBW :Integer;
                var A :Array of Extended; E21 :Extended; M :Integer;
                var W :Array of Extended; var Z :Array of Extended;
                var IERR :Integer; NV :Integer;
                var RV :Array of Extended; var RV6 :Array of Extended);
var
I,J,K,R,II,IJ,JJ,KJ,MB,M1,IJ1,ITS,KJ1,M21,MAXJ,MAXK,GROUP :Integer;
U,V,UK,XU,X0,X1,EPS2,EPS3,EPS4,NORM,ORDER,MACHEP :Extended;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37;
begin
MACHEP := SYS051;
IERR := 0;
if ( M = 0 ) 
 then goto _37;
MB := MBW;
if ( E21 < 0.e0 ) 
 then MB := (MBW+1) div 2;
M1 := MB-1;
M21 := M1+MB;
ORDER := 1.e0-Abs(E21);
{      ********** }
for R:=1 to M do
 begin
  ITS := 1;
  X1 := W[R-1];
  if ( R <> 1 ) 
   then goto _4;
{      ********** }
  NORM := 0.e0;
  for J:=1 to MB do
   begin
    JJ := MB+1-J;
    KJ := JJ+M1;
    IJ := 1;
    for I:=JJ to N do
     begin
      NORM := NORM+Abs(A[(I-1)+(J-1)*NM]);
      if ( E21 >= 0.e0 ) 
       then goto _1;
      NORM := NORM+Abs(A[(IJ-1)+(KJ-1)*NM]);
      IJ := IJ+1;
_1:
     end;
_2:
   end;
  if ( E21 < 0.e0 ) 
   then NORM := 0.5e0*NORM;
{      ********** }
  if ( NORM = 0.e0 )  
   then NORM := 1.e0;
  EPS2 := 1.e0-3*NORM*Abs(ORDER);
  EPS3 := MACHEP*NORM;
  UK := Sqrt((N));
  EPS4 := UK*EPS3;
_3:
  GROUP := 0;
  goto _5;
{      ********** }
_4:
  if ( Abs(X1-X0) >= EPS2 ) 
   then goto _3;
  GROUP := GROUP+1;
  if ( ORDER*(X1-X0) <= 0.e0 ) 
   then X1 := X0+ORDER*EPS3;
{      ********** }
_5:
  for I:=1 to N do
   begin
    IJ := I+Min0(0,I-M1)*N;
    KJ := IJ+MB*N;
    IJ1 := KJ+M1*N;
    if ( M1 = 0 ) 
     then goto _10;
    for J:=1 to M1 do
     begin
      if ( IJ > M1 ) 
       then goto _6;
      if ( IJ > 0 ) 
       then goto _7;
      RV[IJ1-1] := 0.e0;
      IJ1 := IJ1+N;
      goto _7;
_6:
      RV[IJ-1] := A[(I-1)+(J-1)*NM];
_7:
      IJ := IJ+N;
      II := I+J;
      if ( II > N ) 
       then goto _9;
      JJ := MB-J;
      if ( E21 >= 0.e0 ) 
       then goto _8;
      II := I;
      JJ := MB+J;
_8:
      RV[KJ-1] := A[(II-1)+(JJ-1)*NM];
      KJ := KJ+N;
_9:
     end;
_10:
    RV[IJ-1] := A[(I-1)+(MB-1)*NM]-X1;
    RV6[I-1] := EPS4;
    if ( ORDER = 0.e0 ) 
     then RV6[I-1] := Z[(I-1)+(R-1)*NM];
_11:
   end;
  if ( M1 = 0 ) 
   then goto _20;
{      ********** }
  for I:=1 to N do
   begin
    II := I+1;
    MAXK := Min0(I+M1-1,N);
    MAXJ := Min0(N-I,M21-2)*N;
    for K:=I to MAXK do
     begin
      KJ1 := K;
      J := KJ1+N;
      JJ := J+MAXJ;
      KJ := J;
      while ( KJ<=JJ ) do
       begin
        RV[KJ1-1] := RV[KJ-1];
        KJ1 := KJ;
_12:
        inc(KJ,N);
       end;
      RV[KJ1-1] := 0.e0;
_13:
     end;
    if ( I = N ) 
     then goto _19;
    U := 0.e0;
    MAXK := Min0(I+M1,N);
    MAXJ := Min0(N-II,M21-2)*N;
    for J:=I to MAXK do
     begin
      if ( Abs(RV[J-1]) < Abs(U) ) 
       then goto _14;
      U := RV[J-1];
      K := J;
_14:
     end;
    J := I+N;
    JJ := J+MAXJ;
    if ( K = I ) 
     then goto _16;
    KJ := K;
    IJ := I;
    while ( IJ<=JJ ) do
     begin
      V := RV[IJ-1];
      RV[IJ-1] := RV[KJ-1];
      RV[KJ-1] := V;
      KJ := KJ+N;
_15:
      inc(IJ,N);
     end;
    if ( ORDER <> 0.e0 ) 
     then goto _16;
    V := RV6[I-1];
    RV6[I-1] := RV6[K-1];
    RV6[K-1] := V;
_16:
    if ( U = 0.e0 ) 
     then goto _19;
    for K:=II to MAXK do
     begin
      V := RV[K-1]/U;
      KJ := K;
      IJ := J;
      while ( IJ<=JJ ) do
       begin
        KJ := KJ+N;
        RV[KJ-1] := RV[KJ-1]-V*RV[IJ-1];
_17:
        inc(IJ,N);
       end;
      if ( ORDER = 0.e0 ) 
       then RV6[K-1] := RV6[K-1]-V*RV6[I-1];
_18:
     end;
_19:
 end;
{     **********}
_20:
  for II:=1 to N do
   begin
    I := N+1-II;
    MAXJ := Min0(II,M21);
    if ( MAXJ = 1 ) 
     then goto _22;
    IJ1 := I;
    J := IJ1+N;
    JJ := J+(MAXJ-2)*N;
    IJ := J;
    while ( IJ<=JJ ) do
     begin
      IJ1 := IJ1+1;
      RV6[I-1] := RV6[I-1]-RV[IJ-1]*RV6[IJ1-1];
_21:
      inc(IJ,N);
     end;
_22:
    V := RV[I-1];
    if ( Abs(V) >= EPS3 ) 
     then goto _23;
{      ********** }
    if ( ORDER = 0.e0 ) 
     then IERR := -R;
    V := Sign(EPS3,V);
_23:
    RV6[I-1] := RV6[I-1]/V;
_24:
   end;
  XU := 1.e0;
  if ( ORDER = 0.e0 ) 
   then goto _34;
{      ********** }
  if ( GROUP = 0 ) 
   then goto _28;
  for JJ:=1 to GROUP do
   begin
    J := R-GROUP-1+JJ;
    XU := 0.e0;
    for I:=1 to N do
     begin
_25:
      XU := XU+RV6[I-1]*Z[(I-1)+(J-1)*NM];
     end;
    for I:=1 to N do
     begin
_26:
      RV6[I-1] := RV6[I-1]-XU*Z[(I-1)+(J-1)*NM];
     end;
_27:
   end;
_28:
  NORM := 0.e0;
  for I:=1 to N do
   begin
_29:
    NORM := NORM+Abs(RV6[I-1]);
   end;
  if ( NORM >= 1.e0-1 ) 
   then goto _32;
{      ********** }
  if ( ITS >= N ) 
   then goto _31;
  ITS := ITS+1;
  XU := EPS4/(UK+1.e0);
  RV6[0] := EPS4;
  for I:=2 to N do
   begin
_30:
    RV6[I-1] := XU;
   end;
  RV6[ITS-1] := RV6[ITS-1]-EPS4*UK;
  goto _20;
{      ********** }
_31:
  IERR := -R;
  XU := 0.e0;
  goto _34;
{      ********** }
_32:
  U := 0.e0;
  for I:=1 to N do
   begin
_33:
    U := U+IntPower(RV6[I-1],2);
   end;
  XU := 1.e0/Sqrt(U);
_34:
  for I:=1 to N do
   begin
_35:
    Z[(I-1)+(R-1)*NM] := RV6[I-1]*XU;
   end;
  X0 := X1;
_36:
 end;
_37:
end;

end.
